<template>
  <div v-if="ready">
    <component :is="component_name" v-bind="component_props" v-on="$listeners"></component>
  </div>
</template>

<script>
import Vue from 'vue'
import loadjs from 'loadjs'
/**
 * Ac Dynamic component which will load components by URL
 */
export default {
  name: 'ac-dynamic',

  data() {
    return {
      ready: false,
      component_props: {},
    }
  },

  props: {
    /**
     * @param {array} url - URLs for js and css files of the component
     * Required
     */
    url: {
      type: Array,
      required: true,
    },

    /**
     * @param {array} component_name - Name of the imported component
     * Required
     */
    component_name: {
      type: String,
      required: true,
    },

    /**
     * @param {object} component_props - Props for loaded component
     */
    props: {
      type: Object,
    },

    /**
     * @param {object} props_mapper - Props mapper for loaded component
     */
    props_mapper: {
      type: Object,
    },
  },

  mounted() {
    this.load(this.url, this.loaded)
  },

  watch: {
    props: function() {
      this.component_props = {...this.component_props, ...this.convert_props()}
    }
  },

  methods: {
    load(url, callback) {
      loadjs(url, 'component', {returnPromise: true})
      .then(() => callback())
    },

    loaded() {
      Vue.component(this.component_name, window[this.component_name].default)
      const props = Vue.options.components[this.component_name].options.props
      const converted_props = this.convert_props()
      
      Object.keys(props).forEach(key => {
        if (props[key].default) {
          const defaultType = typeof props[key].default
          const propType = typeof props[key].type
          if (propType === 'function') {
            if (typeof props[key].type() === defaultType) {
              this.component_props[key] = props[key].default
            }
          }
        }
      })
      this.component_props = {...this.component_props, ...converted_props, ...this.props}
      this.ready = true
    },

    convert_props() {
      return Object.keys(this.props).reduce((obj, prop) => {
        if (Object.keys(this.props_mapper).includes(prop)) {
          obj[this.props_mapper[prop]] = this.props[prop]
          return obj
        }
      }, {})
    }
  },
}
</script>
